/*
 @file   CommonFFT.h
 @brief  FFT֘ACu֐̒`
 @param  AdIn Research,Inc
 @date   2007/02/15
*/

#ifndef  __COMMON_FFT_H__
#define  __COMMON_FFT_H__


//=============================================================================
//  ֐̎ނ`
//=============================================================================
#define WLWF_NONE               (0)
#define WLWF_SQUARE             (WLWF_NONE)
#define WLWF_HANNING            (1)
#define WLWF_HAMMING            (2)
#define WLWF_BLACKMAN           (3)
#define WLWF_BLACKMANHARRIS     (4)
#define WLWF_BARTLETT           (5)
#define WLWF_PARZEN             (6)
#define WLWF_WELCH              (7)
#define WLWF_RIESZ              (8)
#define WLWF_SIN                (9)
#define WLWF_TRIANGULAR         (10)


//=============================================================================
//	Global function prototype
//=============================================================================

// [pXtB^[
bool LPF_Butterworth2(  int            nData,         // (in) f[^z̗vf
                        const double*  pdIn,          // (in) f[^z
                        double*        pdOut,         // (out) tB^[f[^z
                        double         dCutOffFreq,   // (in) JbgItg
                        double         dSampleFreq ); // (in) TvOg

// ֐Kp
bool Windowing(  int           iWF,     // (in) ֐̎
                 int           nData,   // (in) f[^z̗vf
                 const double* pdIn,    // (in) f[^z
                 double*       pdOut ); // (out) ֐Kp̃f[^z

// t[Gϊs
bool FFT(  int           nData,     // (in) f[^z̗vf
           const double* pdIn,      // (in) f[^z
           double*       pdReal,    // (out) ̃f[^z
           double*       pdImag,    // (out) ̃f[^z
           double*       pdPower ); // (out) p[XyNgf[^z


#endif // __COMMON_FFT_H__
