// -*-C++-*-
/*!
 * @file  PowerInfoSVC_impl.cpp
 * @brief Service implementation code of PowerInfo.idl
 * @date  $Date: 2007/01/11 07:44:39 $
 *
 * $Id: cxx_svc_impl.py,v 1.3 2007/01/11 07:44:39 n-ando Exp $
 */

#include "PowerInfoSVC_impl.h"

#include	"CPowerSp.h"

extern CPowerSp	g_cPS;

/*
 * Example implementational code for IDL interface PowerInfo
 */
PowerInfoSVC_impl::PowerInfoSVC_impl()
{
  // Please add extra constructor code here.
}


PowerInfoSVC_impl::~PowerInfoSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Short PowerInfoSVC_impl::SetParam(	CORBA::Short iWndFunc, 
											CORBA::Double dLowerLimit, 
											CORBA::Double dUpperLimit, 
											CORBA::Short iOutputCount)
{
	g_cPS.SetParam( iWndFunc, dLowerLimit, dUpperLimit, iOutputCount );
	return 0;
}

CORBA::Short PowerInfoSVC_impl::GetParam(	CORBA::Short& iWndFunc, 
											CORBA::Double& dLowerLimit, 
											CORBA::Double& dUpperLimit, 
											CORBA::Short& iOutputCount)
{
	int		iWF, iOut;
	double	dLow, dUp;

	g_cPS.GetParam( &iWF, &dLow, &dUp, &iOut );
	iWndFunc = (short)iWF;
	dLowerLimit = dLow;
	dUpperLimit = dUp;
	iOutputCount = (short)iOut;
	return 0;
}



// End of example implementational code



