// -*-C++-*-
/*!
 * @file  PowerInfoSVC_impl.h
 * @brief Service implementation header of PowerInfo.idl
 * @date  $Date: 2007/01/11 07:44:39 $
 *
 * $Id: cxx_svc_impl.py,v 1.3 2007/01/11 07:44:39 n-ando Exp $
 */

#include "PowerInfoSkel.h"


#ifndef POWERINFOSVC_IMPL_H
#define POWERINFOSVC_IMPL_H
 
/*
 * Example class implementing IDL interface PowerInfo
 */
class PowerInfoSVC_impl
 : public virtual POA_PowerInfo,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~PowerInfoSVC_impl();

 public:
   // standard constructor
   PowerInfoSVC_impl();
   virtual ~PowerInfoSVC_impl();

   // attributes and operations
   CORBA::Short SetParam(CORBA::Short iWndFunc, CORBA::Double dLowerLimit, CORBA::Double dUpperLimit, CORBA::Short iOutputCount);
   CORBA::Short GetParam(CORBA::Short& iWndFunc, CORBA::Double& dLowerLimit, CORBA::Double& dUpperLimit, CORBA::Short& iOutputCount);

};



#endif // POWERINFOSVC_IMPL_H


