/*
  @file CGuiCore.cpp
  @brief Gui ݡͥȤΥᥤ󥯥饹
  @author AdIn Research,Inc
  @date 2007/03/27
*/


#define WINDOW_TITLE        "BetaRNA voice detect demo"
#define STRING_BUFF_SIZE   128
#define WAVE_MAX_SIZE      1024
#define MAX_PATH           256
#define VOICE_DIR          "voice/"
#define REASONING_DIR      "reasoning"


#include "CGuiCore.h"
#include "interface.h"


/*
  @brief 󥹥ȥ饯
  @author AdIn Research,Inc
  @date 2007/03/27
*/
CGuiCore::CGuiCore( void )
{
  m_txWinFunc = NULL;
  m_txLowerLim = NULL;
  m_txUpperLim = NULL;
  m_txPowerDev = NULL;
  m_txBetaDir = NULL;
  m_txTalker = NULL;
  m_txResult = NULL;
  m_barStat = NULL;

  m_pGUIComp = NULL;
  m_iTalker = -1;
}


/*
  @brief ǥȥ饯
  @author AdIn Research,Inc
  @date 2007/03/27
*/
CGuiCore::~CGuiCore( void )
{
}


/*!
  @brief ̼¹Դؿ
  @author AdIn Research,Inc
  @date 2007/03/27
*/
void CGuiCore::Run( void )
{
  GtkWidget* pMainWindow;

  // GTK
  gtk_set_locale();
  gtk_init( NULL, NULL );
  
  // ɥκ
  pMainWindow = create_wndMain();
  gtk_window_set_title( GTK_WINDOW(pMainWindow), WINDOW_TITLE );

  // ɥɽ
  gtk_widget_show( pMainWindow );

  // ᥤ롼פ
  gtk_main();
}


/*
  @brief GUIݡͥȤƥֲ줿Ȥ˸ƤФ
  @param[in] pGUIComp GUIݡͥȥݥ
  @author AdIn Research,Inc
  @date 2007/03/27
*/
void CGuiCore::OnActivate( GUI* pGUIComp )
{
  short  iWF/*Window function*/, iOut/*Power devide num*/;
  double dLow/*Lower limit freq*/, dUp/*Upper limit freq*/;
  gchar  sBuf[STRING_BUFF_SIZE];

  m_pGUIComp = pGUIComp;
  if( m_pGUIComp == NULL ) return;

  // PowerInfoӥݡȤ顢"Window function""Lower limit freq""Upper limit freq""Power devide num"ͤ
  try {
    m_pGUIComp->m_PowerInfo0->GetParam( iWF, dLow, dUp, iOut );
  }
  catch(...) {
    // ̲ΥơСˡ֤ɽ
    sprintf( sBuf, "Error in service port( PowerInfo ), check connection." );
    Status( sBuf );
    return;
  }

  // "Window function"򡢲̤ɽ
  sprintf( sBuf, "%d", iWF );
  SetEntryText( m_txWinFunc, (const gchar*)sBuf );
  
  // "Lower limit freq"ͤ򡢲̤ɽ
  sprintf( sBuf, "%lf", dLow );
  SetEntryText( m_txLowerLim, (const gchar*)sBuf );

  // "Upper limit freq"ͤ򡢲̤ɽ
  sprintf( sBuf, "%lf", dUp );
  SetEntryText( m_txUpperLim, (const gchar*)sBuf );

  // "Power devide num"ͤ򡢲̤ɽ
  sprintf( sBuf, "%d", iOut );
  SetEntryText( m_txPowerDev, (const gchar*)sBuf );

  // "BetaRNADir"˥եƤ
  gtk_widget_grab_focus( GTK_WIDGET( m_txBetaDir ) );	

  // ̲ΥơСˡ֤ɽ
  Status( "Ready" );
}


/*!
  @brief GUIݡͥȤˡǡϤ줿Ȥ˸ƤФ
  @author AdIn Research,Inc
  @date 2007/03/27
*/
void CGuiCore::OnGetSound( void )
{
  int i;
  gchar sBuf[STRING_BUFF_SIZE];

  // ǡΥå
  if( m_pGUIComp->m_Size.data < WAVE_MAX_SIZE ) {
    sprintf( sBuf, "Too small(%d) voice recieved, ignore.", m_pGUIComp->m_Size.data );
    Status( sBuf );
    return;
  }

  // ǡ򡢲̲ΥơСɽ
  sprintf( sBuf, "Voice data recieve. size = %d.", m_pGUIComp->m_Size.data );
  Status( sBuf );

  // ǡGUIݡͥȤνϥݡȤ
  m_pGUIComp->m_SendSize.data = m_pGUIComp->m_Size.data;

  // ǡGUIݡͥȤνϥݡȤ
  m_pGUIComp->m_SendWave.data.length( m_pGUIComp->m_SendSize.data );
  for( i = 0; i < m_pGUIComp->m_SendSize.data; i++ )
    m_pGUIComp->m_SendWave.data[i] = m_pGUIComp->m_Wave.data[i];

  // ǡǡGUIݡͥȤνϥݡȤϤ
  m_pGUIComp->m_SendSizeOut.write();
  m_pGUIComp->m_SendWaveOut.write();

  return;
}


/*
  @brief GUIݡͥȤˡħ̥ǡϤ줿Ȥ˸ƤФ
  @author AdIn Research,Inc
  @date 2007/03/27
*/
void CGuiCore::OnGetPower( void )
{
  int i, iRet;
  BetaRna::DArray array;
  short  iResult;
  double dTrusty;
  gchar  sBuf[STRING_BUFF_SIZE];
  char*  sName;

  // GUIݡͥȤΥǡϥݡȤꡢħ̥ǡ
  array.length( m_pGUIComp->m_DataCount.data );
  for( i = 0; i < (int)array.length(); i++ )
    array[i] = m_pGUIComp->m_DataAry.data[i];

  // ؽݡͥ(-RNAݡͥ)˽
  try {
    iRet = m_pGUIComp->m_BetaRna0->Exec( m_iTalker, array, iResult, dTrusty );
  }
  catch(...) {
    // ̲ΥơСˡ֤ɽ
    sprintf( sBuf, "Error in service port( BetaRna ), check connection." );
    Status( sBuf );
    return;
  }

  // ؽݡͥ(-RNAݡͥ)ν̤顼ξ
  if( iRet ) {
    // ̲ΥơСˡ֤ɽ
    sprintf( sBuf, "Error in BetaRnaService::Exec(), ret = %d.", iRet );
    Status( sBuf );
    return;
  }

  // TalkManagerCompݡͥȤ顢ü̾
  try {
    if( m_iTalker < 0 )
      sName = m_pGUIComp->m_TalkerMng0->GetName( iResult );
    else
      sName = m_pGUIComp->m_TalkerMng0->GetName( m_iTalker );
  }
  catch(...) {
    // ̲ΥơСˡ֤ɽ
    sprintf( sBuf, "Error in service port( TalkerMng ), check connection." );
    Status( sBuf );
    return;
  }

  // ؽ̤ɽ
  if( m_iTalker < 0 )
    sprintf( sBuf, "Talker is %s, trust(%lf%%)", sName, dTrusty );
  else
    sprintf( sBuf, "Learned %s voice", sName );
  Result( sBuf );

  // ̲ΥơСˡ֤ɽ
  Status( "Ready" );

  return;
}

/*
  @brief      ɥ˲줿Ȥ
  @author     AdIn Research,Inc
  @date       2007/03/27
*/
void CGuiCore::OnDestroy( GtkObject* pObject, gpointer user_data )
{
  exit( 0 );
}

/*
  @brief      ܥ󤬲줿Ȥ
  @author     AdIn Research,Inc
  @date       2007/03/27
*/
void CGuiCore::OnSetParamButtonClicked( GtkButton* pButton, gpointer user_data )
{
  const gchar* sEntry;
  int          iRet, iWF, iOut;
  double       dLow, dUp;
  gchar        sBuf[STRING_BUFF_SIZE];

  // Get param from gtk_entry
  sEntry = gtk_entry_get_text( GTK_ENTRY( m_txWinFunc ) );
  iWF = atoi( sEntry );
  sEntry = gtk_entry_get_text( GTK_ENTRY( m_txLowerLim ) );
  dLow = atof( sEntry );
  sEntry = gtk_entry_get_text( GTK_ENTRY( m_txUpperLim ) );
  dUp = atof( sEntry );
  sEntry = gtk_entry_get_text( GTK_ENTRY( m_txPowerDev ) );
  iOut = atoi( sEntry );

  // check param
  if( iWF < 1 || iWF > 10 || dLow < 0.0 || dLow > dUp || dUp > 10000.0 || iOut < 2 || iOut > 20 ) {
    sprintf( sBuf, "Bad param, check value." );
    Status( sBuf );
    return;
  }
  // set power params
  try {
    m_pGUIComp->m_PowerInfo0->SetParam( iWF, dLow, dUp, iOut );
  }
  catch(...) {
    sprintf( sBuf, "Error in service port( PowerInfo ), check connection." );
    Status( sBuf );
    return;
  }

  // init rna
  sEntry = gtk_entry_get_text( GTK_ENTRY( m_txBetaDir ) );
  try {
    iRet = m_pGUIComp->m_BetaRna0->Init( (const char*)sEntry, iOut );
  }
  catch(...) {
    sprintf( sBuf, "Error in service port( BetaRna ), check connection." );
    Status( sBuf );
    return;
  }


  if( iRet ) {
    sprintf( sBuf, "Error in BetaRnaService::Init(), ret=%d", iRet );
    Status( sBuf );
  }
  Status( "Initialize complete." );
}

/*
  @brief      եܥ󤬲줿Ȥ
  @author     AdIn Research,Inc
  @date       2007/03/27
*/
void CGuiCore::OnFileButtonClicked( GtkButton* pButton, gpointer user_data )
{
  GtkWidget* dlgFile;
  char       sPath[MAX_PATH];
  int        iRet;

  iRet = GetTalkerID( sPath );
  if( iRet < -1 )
    return;
  m_iTalker = iRet;

  dlgFile = gtk_file_selection_new( "Select voice file." );
  gtk_signal_connect( GTK_OBJECT( GTK_FILE_SELECTION( dlgFile )->ok_button ),
                      "clicked", GTK_SIGNAL_FUNC( GetPath ), (gpointer)dlgFile );
  gtk_signal_connect_object( GTK_OBJECT( GTK_FILE_SELECTION( dlgFile )->ok_button ),
                      "clicked", GTK_SIGNAL_FUNC( gtk_widget_destroy), (gpointer)dlgFile );
  gtk_signal_connect_object( GTK_OBJECT( GTK_FILE_SELECTION( dlgFile )->cancel_button ),
                      "clicked", GTK_SIGNAL_FUNC( gtk_widget_destroy), (gpointer)dlgFile );

  gtk_widget_show( dlgFile );
}

/*
  @brief      ޥܥ󤬲줿Ȥ
  @author     AdIn Research,Inc
  @date       2007/03/27
*/
void CGuiCore::OnMicButtonClicked( GtkButton* pButton, gpointer user_data )
{
  char sPath[MAX_PATH];
  int  iRet;

  // üID
  iRet = GetTalkerID( sPath );
  if( iRet < -1 )
    return;

  m_iTalker = iRet;

  // ޥϥݡͥȤˡޥϤ¥
  m_pGUIComp->m_Trigeger.data = CORBA::string_dup( sPath );
  m_pGUIComp->m_TrigegerOut.write();

  // ɽ򥯥ꥢ
  Result( "" );

  // ̲ΥơСˡ֤ɽ
  Status( "Waiting voice." );
}





/*
  @brief      üID
  @param[out] sPath եǼǥ쥯ȥѥ
  @return     int üID
  @author     AdIn Research,Inc
  @date       2007/03/27
*/
int CGuiCore::GetTalkerID( char* sPath )
{
  const gchar* sEntry;
  gchar        sBuf[STRING_BUFF_SIZE];
  int          iRet;

  *sPath = 0x00;

  // ü̾
  sEntry = gtk_entry_get_text( GTK_ENTRY( m_txTalker ) );

  if( *sEntry == '?' ){ // ⡼ɤΤȤϡü̾ʤ
    sprintf( sPath, VOICE_DIR "%s", REASONING_DIR );
    return -1;
  }

  if( ! strlen( sEntry ) ) { // ü̾ꤵƤʤ
    Status( "Enter talker name or '?'" );
    return -2;
  }

  // TalkerManageݡͥȤ顢ӥݡȷͳǡüID
  try {
    iRet = m_pGUIComp->m_TalkerMng0->GetID( sEntry );
  }
  catch(...) {
    sprintf( sBuf, "Error in service port( TalkerMng ), check connection." );
    Status( sBuf );
    return -2;
  }

  // եǼǥ쥯ȥѥ
  sprintf( sPath, VOICE_DIR "/%s", sEntry );

  return iRet;
}


/*
  @brief     եѥ
  @param[in] sel
  @param[in] user_data
  @author    AdIn Research,Inc
  @date      2007/03/27
*/
void CGuiCore::GetPath( GtkFileSelection* sel, gpointer user_data )
{
  extern CGuiCore g_cCore;
  const gchar* sPath;
  GtkWidget*   dlgFile;

  // եươեѥ
  dlgFile = (GtkWidget*)user_data;
  sPath = gtk_file_selection_get_filename( GTK_FILE_SELECTION( dlgFile ) );

  // եѥGUIݡͥȤΥǡϥݡȤꤹ
  g_cCore.m_pGUIComp->m_File.data = CORBA::string_dup( sPath );
  // եѥGUIݡͥȤΥǡϥݡȤ顢Ϥ
  g_cCore.m_pGUIComp->m_FileOut.write();

  // ɽ򥯥ꥢ
  g_cCore.Result( "" );
  // ̲ΥơСˡʸɽ
  g_cCore.Status( "Waiting voice." );
}


/*
  @brief     ̲ΥơСˡʸɽ
  @param[in] pMessage ʸ
  @author    AdIn Research,Inc
  @date      2007/03/27
*/
void CGuiCore::Status( const gchar* pMessage )
{
  static bool  bIsFirst = true;
  static guint iConID = 0;

  if( bIsFirst ) {
    iConID = gtk_statusbar_get_context_id( GTK_STATUSBAR( m_barStat ), "Status" );
    bIsFirst = false;
  }
  else {
    gtk_statusbar_pop( GTK_STATUSBAR( m_barStat ), iConID );
  }

  gtk_statusbar_push( GTK_STATUSBAR( m_barStat ), iConID, (const gchar*)pMessage );
  gtk_widget_queue_draw( GTK_WIDGET( m_barStat ) );
}



/*
  @brief     Resultˡʸɽ
  @param[in] pMessage ʸ
  @author    AdIn Research,Inc
  @date      2007/03/27
*/
void CGuiCore::Result( const gchar* pMessage )
{
  SetEntryText( m_txResult, pMessage );
}

/*
  @brief     entryˡʸɽ
  @param[in] pEntry entrey
  @param[in] pText ʸ
  @author    AdIn Research,Inc
  @date      2007/03/27
*/
void CGuiCore::SetEntryText( GtkWidget* pEntry, const gchar* pText )
{
  if( pEntry == NULL ) return;

  gtk_widget_grab_focus( GTK_WIDGET( pEntry ) );
  gtk_entry_set_text( GTK_ENTRY( pEntry ), (pText == NULL)? "":(const gchar*)pText );
//  gtk_widget_queue_draw( GTK_WIDGET( pEntry ) );
}

