// -*- C++ -*-
/*!
 * @file  StdIn.cpp
 * @brief Standerd input component
 * $Date$
 *
 * $Id$
 */

#include "StdIn.h"

// Module specification
// <rtc-template block="module_spec">
static const char* stdin_spec[] =
  {
    "implementation_id", "StdIn",
    "type_name",         "StdIn",
    "description",       "Standerd input component",
    "version",           "0.1",
    "vendor",            "",
    "category",          "Generic",
    "activity_type",     "COMMUTATIVE",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

StdIn::StdIn(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_InstrOut("Instr", m_Instr),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  registerOutPort("Instr", m_InstrOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

StdIn::~StdIn()
{
}


/*
RTC::ReturnCode_t StdIn::onInitialize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

extern char g_sMsg[1024];

RTC::ReturnCode_t StdIn::onExecute(RTC::UniqueId ec_id)
{
  char sBuf[256];
  char* ptr;

  // [UɁAbZ[Wo͂
  if( strlen( g_sMsg ) )
    fprintf( stdout, "%s: ", g_sMsg );
  else
    fprintf( stdout, "Enter data:" );

  // [U̓͂擾
  fgets( sBuf, 255, stdin );

  // s΁As܂łAf[^ƂĈ
  ptr = strchr( sBuf, '\n' );
  if( ptr )
    *ptr = 0x00;

  // [U͕Af[^o̓|[gɐݒ肷
  m_Instr.data = CORBA::string_dup( sBuf );
  // [U͕Af[^o̓|[gAo͂
  m_InstrOut.write();

  sleep( 5 );

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t StdIn::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t StdIn::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void StdInInit(RTC::Manager* manager)
  {
    RTC::Properties profile(stdin_spec);
    manager->registerFactory(profile,
                             RTC::Create<StdIn>,
                             RTC::Delete<StdIn>);
  }
  
};


