/*
  @file   CNameTable.cpp
  @brief  Oe[uNX
  @author AdIn Research,Inc
  @date   2007/02/21
*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "CNameTable.h"


/*
  @brief  Oe[ut@CɁAf[^ۑ
  @return bool
  @author AdIn Research,Inc
  @date   2007/02/21
*/
bool CNameTable::save( void )
{
  FILE* fp;
  int   i;

  // Oe[ut@CJ
  fp = fopen( NS_SAVE_FILE, "wt" );
  if( fp == NULL ) {
    fprintf( stderr, "cannot open" NS_SAVE_FILE );
    return false;
  }

  // Oe[ut@CɁAPsf[^o
  for( i = 0; i < m_iUse; i++ )
    fprintf( fp, "%s\n", m_aSet[i].sName );

  // ㏈
  fclose( fp );

  return true;
}

/*
  @brief  Oe[ut@CAf[^ǂݍ
  @return bool
  @author AdIn Research,Inc
  @date   2007/02/21
*/
bool CNameTable::load( void )
{
  FILE* fp;
  char  sBuf[256];
  char* ptr;

  m_iUse = 0;

  // Oe[ut@CJ
  fp = fopen( NS_SAVE_FILE, "rt" );
  if( fp == NULL ) {
    fprintf( stderr, "cannot open" NS_SAVE_FILE );
    return false;
  }

  // Oe[ut@CAPsf[^ǂݍ
  while( fgets( sBuf, 255, fp ) ) {

    // s΁AI[ɒu
    ptr = strchr( sBuf, '\n' );
    if( ptr ) *ptr = 0x00;

    if( strlen( sBuf ) ) {

      // f[^ő吔`FbN
      if( m_iUse >= NS_TABLE_MAX ) {
        fprintf( stderr, "Table size over.\n" );
        fclose( fp );
        return false;
      }

      // ǂݍ񂾃f[^ێ
      strcpy( m_aSet[m_iUse].sName, sBuf );
      m_iUse++;
    }
  }

  // ㏈
  fclose( fp );

  return true;
}


/*
  @brief     ̂L[ƂāAOe[uāAOID擾
  @param[in] sName L[
  @return    int OID (Ȃꍇ́A-1)
  @author    AdIn Research,Inc
  @date      2007/02/21
*/
int CNameTable::search( const char* sName )
{
  int i;

  for( i = 0; i < m_iUse; i++ )
    if( ! strcmp( sName, m_aSet[i].sName ) )
      return i;

  return -1;
}


/*
  @brief  RXgN^
  @author AdIn Research,Inc
  @date   2007/02/21
*/
CNameTable::CNameTable( void )
{
  load();
}

/*
  @brief  fXgN^
  @author AdIn Research,Inc
  @date   2007/02/21
*/
CNameTable::~CNameTable( void )
{
}

/*
  @brief     OAOID擾
  @param[in] sName O
  @return    int OID (擾łȂꍇ́A-1)
  @author    AdIn Research,Inc
  @date      2007/02/21
*/
int CNameTable::GetID( const char* sName )
{
  int iRet;

  // Oe[u
  iRet = search( sName );

  // Oe[uɁAOꍇ
  if( iRet >= 0 ) {
    return iRet; // Oe[uɒ`ς݂IDԂ
  }
  // Oe[uɁAOꍇ
  else {
    // e[ũf[^TCY`FbN
    if( m_iUse >= NS_TABLE_MAX ) {
      fprintf( stderr, "Can not regist name !\n" );
      return -1; // őf[^ɒBĂ̂ŁAVOo^łȂ
    }

    // VKɖ̂ǉ
    strcpy( m_aSet[ m_iUse ].sName, sName );
    m_iUse++;

    // ̃e[ut@CɁAf[^XVςݖ̃e[uۑ
    if( save() == false ){
      m_iUse--;
      return -1;
    }

    return m_iUse - 1;
  }
}


/*
  @brief     OIDAO擾
  @param[in] iID OID
  @return    int O (擾łȂꍇ́A"????")
  @author    AdIn Research,Inc
  @date      2007/02/21
*/
const char* CNameTable::GetName( int iID )
{
  if( iID >= 0 && iID < m_iUse )
    return m_aSet[ iID ].sName;
  else
    return "????";
}
