// -*- C++ -*-
/*!
 * @file  TalkerManage.cpp
 * @brief Talker name and id manage component
 * $Date$
 *
 * $Id$
 */

#include "TalkerManage.h"

// Module specification
// <rtc-template block="module_spec">
static const char* talkermanage_spec[] =
  {
    "implementation_id", "TalkerManage",
    "type_name",         "TalkerManage",
    "description",       "Talker name and id manage component",
    "version",           "0.1",
    "vendor",            "",
    "category",          "Generic",
    "activity_type",     "COMMUTATIVE",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

TalkerManage::TalkerManage(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_TalkerMngPort("TalkerMng"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  m_TalkerMngPort.registerProvider("TalkerMng0", "TalkerMng", m_TalkerMng0);
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  registerPort(m_TalkerMngPort);
  
  // </rtc-template>

}

TalkerManage::~TalkerManage()
{
}


/*
RTC::ReturnCode_t TalkerManage::onInitialize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TalkerManage::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void TalkerManageInit(RTC::Manager* manager)
  {
    RTC::Properties profile(talkermanage_spec);
    manager->registerFactory(profile,
                             RTC::Create<TalkerManage>,
                             RTC::Delete<TalkerManage>);
  }
  
};


