/*
  @file   CJuliusRecv.h
  @brief  Julius -> adintool ̋NyюMNX
  @author AdIn Research,Inc
  @date   2007/03/03
*/
#ifndef  __C_JUIIUS_RECV_H__
#define  __C_JUIIUS_RECV_H__

#include  <pthread.h>
#include  "CWaveData.h"

#define  JR_INI_NAME   "jr.ini" // ݒt@CpX


class CJuliusRecv
{
public:
  CJuliusRecv( void );
  ~CJuliusRecv( void );

  bool Init( void );
  void SetDir( const char* sPath );
  int GetSize( void );
  const short* Read( void );

private:
  //  (Julius adintool) c[֘A
  int            m_iPortNo;             // |[gԍ
  char           m_sAdinPath[PATH_MAX]; // ̓c[̃pX
  int            m_iSamplingRate;       // TvO[g
  int            m_iSelectInterval;     // select() ҂
  int            m_iSegment;            // L 0:A1:L
  int            m_iRecMax;             // ő^(sec)
  int            m_iSave;               // ^H

  // Xbh֘A
  bool           m_bRunningThread;      // XbhĂH
  pthread_t      m_tRecvThread;         // MXbh

  // vZX֘A
  int            m_iJuliusID;           // adintool ̋NvZXID

  // \Pbg֘A
  int            m_iListenSock;         // listen sock
  int            m_iRecvSock;           // recv sock

  // obt@֘A
  bool           m_bRecv;               // MtO false ͓̎ǂݎ̂Ă
  int            m_iRecvSize;           // Mobt@TCYiBytej
  int            m_iRecv;               // MTCY
  unsigned char* m_pRecvBuf;            // Mobt@

  // ۑfBNg֘A
  char           m_sDir[PATH_MAX];      // ^fBNg
  int            m_iSeq;

private:
  bool loadSetting( void );
  void saveSetting( void );

  static void* invokeRecvThread( void* pParam );
  void* onRecv();

  int execJulius( int iPort, const char* sAdinPath, int iSamplingRate, int iSegmentUse );
  bool makeDir( const char* sPath );
  int createListen( int iPort );
  int readSelect( int iTimeout, int iSock );
  int readBlock( int iSock, char* sRead );
};
#endif // __C_JUIIUS_RECV_H__
