/*******************************************************************************
 *      (C)Copyright       AdIn Reserch, Inc.                 1991-1993.       *
 *******************************************************************************
 *******************************************************************************
 *
 *  File name    : mmi00def.h
 *
 *  Note         : Header file for B-RNA graphic mmi
 *                     - for MMI library -
 *
 * $Revision: 2.27 $
 * $Author: fujimaki $
 * $Date: 1999/11/05 03:04:05 $
 * $Locker:  $
 *
 ******************************************************************************/
 
#if !defined(_MMI00DEF_H_)
#   define _MMI00DEF_H_

/*----- Include files --------------------------------------------------------*/
#include    "rna01usr.h"
#if defined(MEMDBG)
#   include "Kcommon.h"
#endif
#include    "rnaL0usr.h"
#include    "rnaB0usr.h"
#include    "rnaF0usr.h"
#include    "mmi00usr.h"

#include    <X11/Intrinsic.h>
#include    <X11/StringDefs.h>
#include    <X11/Xlib.h>
#include    <X11/Shell.h>

/* shell */
#include    <Xm/DialogS.h>
/* manager */
#include    <Xm/BulletinB.h>
#include    <Xm/Form.h>
#include    <Xm/RowColumn.h>
#include    <Xm/DrawingA.h>
#include    <Xm/Frame.h>
#include    <Xm/PanedW.h>
/* widget set */
#include    <Xm/FileSB.h>
#include    <Xm/MessageB.h>
#include    <Xm/SelectioB.h>
#include    <Xm/ScrolledW.h>
/* primitive */
#include    <Xm/Text.h>
#include    <Xm/List.h>
#include    <Xm/Label.h>
#include    <Xm/PushB.h>
#include    <Xm/DrawnB.h>
#include    <Xm/ToggleB.h>
#include    <Xm/CascadeB.h>
#include    <Xm/Scale.h>
#include    <Xm/ScrollBar.h>
/* gedget */
#include    <Xm/LabelG.h>
#include    <Xm/PushBG.h>
#include    <Xm/ToggleBG.h>
#include    <Xm/CascadeBG.h>
#include    <Xm/SeparatoG.h>

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/*============================================================================*/
/*============= Macro / enum =================================================*/
/*============================================================================*/

/*----- Define integer length (for RID, RNUM, RANA, int, uint, long, ulong)---*/
#define     RmINT_LEN           (12)             /* display value length */
#define     RmID_MAXLEN         (15)             /* ID max length        */
#define     RmRANA_SCALE_MAX    ((int)32767)     /* scale widget maximum */
#define     RmPERCENT_MIN       (0)              /* percent min          */
#define     RmPERCENT_MAX       (100)            /* percent max          */
#define     RmACTIVE_SHADOW     (4)              /* data active shadow   */
#define     RmINACTIVE_SHADOW   (1)              /* data inactive shadow */
#define     RmINTERVAL_SEC      (500)            /* time out interval    */
#define     RmSZ_ID             (30)             /* size of ID           */
#define     RmSZ_NAME           (160)            /* size of Name         */
#define     RmRLMATCH_MODE (RLMM_ACTPS | RLMM_ACTMF)    /* matching mode */

/*----- Define Xm Version ----------------------------------------------------*/
#if XmVERSION == 1
#   if XmREVISION == 0                 /* Motif 1.0 */
#      define  RmXMVERSION     (1)
#   else
#   if XmREVISION == 1                 /* Motif 1.1 */
#      define  RmXMVERSION     (2)
#   else
#   if XmREVISION == 2                 /* Motif 1.2 */
#      define  RmXMVERSION     (3)
#   endif
#   endif
#   endif
#endif

/*----- Define X function ----------------------------------------------------*/
#if RmXMVERSION < 2
#   define  XtAppInitialize(papctext, apclass, op, nop, ac, av, res, ag, nag) \
           (XtInitialize(apclass, apclass, NULL, 0, ac, av))
#   define  XtAppMainLoop(apctext) \
           (XtMainLoop())
#   define  XtAppCreateShell(apname, apclass, wdclass, disp, ag, nag) \
           (XtCreateApplicationShell(apname, wdclass, ag, nag))
#   define  XtAppAddTimeOut(apctext, interval, proc, cldata) \
           (XtAddTimeOut(interval, proc, cldata))
#   define  XtAppSetErrorHandler(apctext, handler) \
           (XtSetErrorHandler(handler))
#   define  XtAppSetWarningHandler(apctext, handler) \
           (XtSetWarningHandler(handler))
#   define  XtAppAddActions(apctext, actions, nactions) \
           (XtAddActions(actions, nactions))
#endif
#define rXtAddCallback(w, name, cb, cl) \
        XtAddCallback(w, name, (XtCallbackProc)cb, (XtPointer)(cl))
#define rXtRemoveCallback(w, name, cb, cl) \
        XtRemoveCallback(w, name, (XtCallbackProc)cb, (XtPointer)(cl))
#define rXtAddEventHandler(w, mask, bool, cb, cl) \
        XtAddEventHandler(w, mask, bool, (XtEventHandler)cb, (XtPointer)(cl))
#define rXtRemoveEventHandler(w, mask, bool, cb, cl) \
        XtRemoveEventHandler(w, mask, bool, (XtEventHandler)cb, (XtPointer)(cl))

/*------ Define dialog modal -------------------------------------------------*/
#if defined(OPENWINDOWS2)
#   define  RmDIALOG_MODAL      XmDIALOG_MODELESS
#   define  RmDIALOG_MODAL_EASY XmDIALOG_MODELESS
#else
#   if RmXMVERSION < 2
#      define  XmDIALOG_PRIMARY_APPLICATION_MODAL  XmDIALOG_APPLICATION_MODAL
#      define  XmDIALOG_FULL_APPLICATION_MODAL     XmDIALOG_SYSTEM_MODAL
#   endif
#   if !defined(NDEBUG)
#      define  RmDIALOG_MODAL      XmDIALOG_PRIMARY_APPLICATION_MODAL
#      define  RmDIALOG_MODAL_EASY XmDIALOG_MODELESS
#   else
#      define  RmDIALOG_MODAL      XmDIALOG_FULL_APPLICATION_MODAL
#      define  RmDIALOG_MODAL_EASY XmDIALOG_PRIMARY_APPLICATION_MODAL
#   endif
#endif

/*----- rint function --------------------------------------------------------*/
#define  RmRint(d)    (((int)((d) * 10.0) % 10) < 5 ? floor(d) : ceil(d))

/*----- Message Type / Button Type -------------------------------------------*/
typedef enum {
    RmERR, RmINF, RmQES, RmWNG, RmWRK, RmMSG
} RmMessage;

typedef enum {
    RmNO_ANS, RmYES_NO, RmOK_CAN, RmOK_ONLY
} RmAnswer;

typedef enum {
    RmYES, RmNO, RmOK, RmCAN
} RmButton;

/*----- Operation Type -------------------------------------------------------*/
typedef enum {
    RmINSERT, RmAPPEND, RmDELETE,
    RmSET,    RmEDIT,   RmCANCEL,
    RmMIX,
    RmNOT_MODIFY
} RmModifyType;

/*----- Table Window draw type -----------------------------------------------*/
typedef enum {
    RmAll, RmAsen, RmDsen, RmPat
} RmDrawType;

/*============================================================================*/
/*============= Structure / Union ============================================*/
/*============================================================================*/

/*----- input MF values information ------------------------------------------*/
typedef struct {
    double dCenter;     /* center value     */
    double dLvar;       /* left variance    */
    double dRvar;       /* right variance   */
    double dVag;        /* vagueness        */
} RmRMF;

/*----- Lebel access information ---------------------------------------------*/
typedef struct {
    RCAT    rcat;                      /* data type            */
    RID     rid[RID_INDEX_MAX_DCL];    /* ID table             */
    RNUM    rnum;                      /* number of used ID    */
} RmLabelInf;

/*----- Table window diaplay size information --------------------------------*/
typedef struct {
    int     iHeight;   /* view height                          */
    int     iAwidth;   /* analogue sensor view                 */
    int     iDwidth;   /* digital sensor view                  */
    int     iApatW;    /* analogue pattern width (base size)   */
} RmDispSize;

/*----- ID infomation --------------------------------------------------------*/
typedef struct {
    RID     riPG;      /* pattern group ID     */
    RID     riSS;      /* sensor set ID        */
    RID     riPT;      /* pattern table ID     */
    RID     riPS;      /* pattern set ID       */
    RID     riElm;     /* sensor or pattern ID */
} RmIdInf;

/*----- Pattern table/set Display order --------------------------------------*/
typedef struct {
    RID      riPT;          /* pattern table ID      */
    RNUM     rnPset;        /* number of pattern set */
    RID     *priPS;         /* pattern set ID table  */
} RmPtOrder;

/*----- Table window's position information ----------------------------------*/
typedef struct _TableInf_   RmTableInf;

typedef struct {
    RmTableInf  *pmtInf;    /* table information pointer    */
    int          iColumn;   /* display column  -            */
    int          iRow;      /* display row     |            */      
} RmGraphInf;

/*----- Table window information ---------------------------------------------*/
struct _TableInf_ {
                            /*----- Didplay envron -----------------*/
    RmWindowType mwType;    /* window type                          */
    RmPtDispType mpDispTp;  /* pattern display type (table/set)     */
    RmBool       mWeightOn; /* analogue sensor's weight disp mode   */
    RmBool       mAllRun;   /* simulate all running mode            */
    RmBool       mSortOn;   /* table is matching dgree order        */
                            /*----- Widget ID ----------------------*/
    Widget       wTopId;    /* top manager widget ID                */
                            /*----- view size ----------------------*/
    int          iHeight;   /* view height                          */
    int          iAwidth;   /* analogue sensor view                 */
    int          iDwidth;   /* digital sensor view                  */
                            /*----- editable counter ---------------*/
    int          iEditAna;  /* analogue pattern/sensor              */
    int          iEditDig;  /* digital pattern/sensor               */
    int          iEditPat;  /* pattern table/set                    */
                            /*----- top view position now ----------*/
    RID          riPosiAna; /* analogue pattern/sensor              */
    RID          riPosiDig; /* digital pattern/sensor               */
    RID          riPosiPT;  /* pattern table(OrderInf position)     */
    RID          riPosiPS;  /* pattern set(in now pattern table)    */
                            /*----- RNA ID -------------------------*/
    RID          riPG;      /* pattern group ID                     */
    RID          riSS;      /* sensor set ID                        */

    RNUM         rnAna;     /* number of analogue data              */
    RNUM         rnDig;     /* number of digital data               */
    RNUM         rnPtbl;    /* number of pattern table              */

    RmPtOrder   *pmpOrder;  /* pattern table/set display order      */

    RmGraphInf  *pmgInf;    /* graph info table (iH * MAX(iA,iD))   */

    RmTableInf  *pmtPrev;   /* previous table                       */
    RmTableInf  *pmtNext;   /* next table                           */

    GENPTR       gPtr;      /* work pointer (now version is RBOOL)  */
};

#if defined(__cplusplus)
}
#endif /* __cplusplus */

/*============================================================================*/
/*============= Default Widget Names =========================================*/
/*============================================================================*/
#include    "mmi00nam.h"

/*============================================================================*/
/*============= External Functions ===========================================*/
/*============================================================================*/
#include    "mmi00fnc.h"

#endif  /* not _MMI00DEF_H_ */
