/*******************************************************************************
 *      (C)Copyright       AdIn Reserch, Inc.                 1991-1993.       *
 *******************************************************************************
 *******************************************************************************
 *
 *  File name    : mmi00sim.h
 *
 *  Note         : Header file for B-RNA graphic mmi
 *                     - for MMI library (learn parameters) -
 *
 * $Revision: 2.28 $
 * $Author: fujimaki $
 * $Date: 1999/11/05 03:04:05 $
 * $Locker:  $
 *
 ******************************************************************************/
 
#if !defined(_MMI00SIM_H_)
#   define _MMI00SIM_H_

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= include =-=-=-=-=-=-=-=-=-=-=-*/
#include    "mmi00def.h"
#include    "rnaS1usr.h"
#include    "rnaS2usr.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= macro =-=-=-=-=-=-=-=-=-=-=-=-*/
/*--------------------------------------------- number of mode */
#define     RmNLMODE        (7)     /* N of learn mode  */
#define     RmNEMODE        (6)     /* N of execute mode*/
#define     RmNOMODE        (5)     /* N of mix type    */
/*--------------------------------------------- data min-max */
#define     RmGAIN_MIN      ((double)0)
#define     RmGAIN_MAX      ((double)1)
/*--------------------------------------------- type of simulator */
#define     RmRS1           (1)
#define     RmRS2           (2)
/*--------------------------------------------- type of data */
#define     RmRS_INPUT      (1)
#define     RmRS_OUTPUT     (2)
/*--------------------------------------------- type of execution */
#define     RmRS_FIRST      (1)
#define     RmRS_SECOND     (2)
#define     RmRS_INFER      (3)

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= struct =-=-=-=-=-=-=-=-=-=-=-=*/
/*--------------------------------------------- setup editor's information */
typedef struct {
    Widget  wiDraw;
    Widget  wiItem1[2];
    Widget  wiItem2[2];
} RmWidSet;

typedef struct {
    Widget      wiHist;
    Widget      wiMode[2];
} RmWidSetH;

typedef struct {
    Widget      wiDraw;
    Widget      wiLvar[2];
    Widget      wiRvar[2];
    Widget      wiLvag[2];
    Widget      wiRvag[2];
} RmWidSetM;

typedef struct {
    Widget      wiDraw;
    Widget      wiCoff[2];
    Widget      wiSvar;
    Widget      wiSvag;
    Widget      wiAvar;
} RmWidSetC;
/*--------------------------------------------- setup data information */
typedef struct {
    RID             riPGin;         /* input pattern group ID       */
    RID             riPGout;        /* otput pattern group ID       */
    unsigned long   ulMode;         /* execute mode                 */
    unsigned long   ulStat;         /* learn mode                   */
    RLMFP           rlm;            /* MF gain                      */
    RLEXT           rle;            /* extend                       */
    RLWEIGHT        rlw;            /* weight controal              */
    int             iOutMode;       /* output mix mode (rs2)        */
    RNUM            rnActRes;       /* number of grade (rs2)        */
    unsigned long   ulModeO;        /* (rs2)                        */
    unsigned long   ulStatO;        /* (rs2)                        */
    RLMFP           rlmO;           /* (rs2)                        */
    RLEXT           rleO;           /* (rs2)                        */
    RLWEIGHT        rlwO;           /* (rs2)                        */
    RANA            raSysMax;       /* normalize value maximum      */
    char           *sResFile;       /* result outout file name      */
} RmSimSetupInf;
/*--------------------------------------------- setup window information */
typedef struct {
    int           iRStype;          /* simulator type 1:rs1, 2:rs2  */
    int           iExeType;         /* first, second or infer       */
    RmSimSetupInf sInf;
    Widget        wiTop;
    Widget        wiMXset[2];           /* raSyaMax */
    Widget        wiIPGid;
    Widget        wiIEmod[RmNEMODE];    /* ulMode   */
    Widget        wiILbtn[4];
    Widget        wiIDisp;              /* dispSize */
    Widget        wiOPGid;
    Widget        wiOEmod[RmNEMODE];    /* ulModeO  */
    Widget        wiOLbtn[4];
    Widget        wiODisp;              /* dispSize */
    Widget        wiOmode[RmNOMODE];    /* iOutMode */
    Widget        wiGrade;              /* rnActRes */
    Widget        wiResFile;            /* res file */
    Widget        wiResType;            /* res type */
} RmSimSetupEditor;

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= functions =-=-=-=-=-=-=-=-=-=-*/
/*--------------------------------------------- set/get/del */
extern Ferr PROTOTYPE( rmSetLearnMode,   (RCAT, RmIdInf *, unsigned long));
extern Ferr PROTOTYPE( rmSetLearnExt,    (RCAT, RmIdInf *, RLEXT *));
extern Ferr PROTOTYPE( rmSetLearnWeight, (RCAT, RmIdInf *, RLWEIGHT *));
extern Ferr PROTOTYPE( rmSetLearnMfp,    (RCAT, RmIdInf *, RLMFP *));

extern Ferr PROTOTYPE( rmGetLearnMode,
                            (RCAT, RmIdInf *, unsigned long *, RCAT *));
extern Ferr PROTOTYPE( rmGetLearnExt,
                            (RCAT, RmIdInf *, RLEXT *, RCAT *));
extern Ferr PROTOTYPE( rmGetLearnWeight,
                            (RCAT, RmIdInf *, RLWEIGHT *, RCAT *));
extern Ferr PROTOTYPE( rmGetLearnMfp,
                            (RCAT, RmIdInf *, RLMFP *, RCAT *));

extern Ferr PROTOTYPE( rmDelLearnExt,    (RCAT, RmIdInf *));
extern Ferr PROTOTYPE( rmDelLearnWeight, (RCAT, RmIdInf *));
extern Ferr PROTOTYPE( rmDelLearnMode,   (RCAT, RmIdInf *));
extern Ferr PROTOTYPE( rmDelLearnMfp,    (RCAT, RmIdInf *));

extern Ferr PROTOTYPE( rmIsDefLearnExt,   (RCAT, RmIdInf *, RmBool *));
extern Ferr PROTOTYPE( rmIsDefLearnWeight,(RCAT, RmIdInf *, RmBool *));
extern Ferr PROTOTYPE( rmIsDefLearnMode,  (RCAT, RmIdInf *, RmBool *));
extern Ferr PROTOTYPE( rmIsDefLearnMfp,   (RCAT, RmIdInf *, RmBool *));

extern Ferr PROTOTYPE( rmDelLearnModeAll,
                            (RmTableInf *, RmIdInf *, RmBool, RmBool, RmBool));
extern Ferr PROTOTYPE( rmDelLearnExtAll,
                            (RmTableInf *));
extern Ferr PROTOTYPE( rmDelLearnWeightAll,
                            (RmTableInf *));
extern Ferr PROTOTYPE( rmDelLearnMfpAll,
                            (RmTableInf *, RmIdInf *, RmBool, RmBool, RmBool));
extern Ferr PROTOTYPE( rmGetDefaultLPrm, (RmSimSetupInf **));

/*--------------------------------------------- entry window */
extern void    PROTOTYPE( rmGetLPrmEntrytypeDeltype,
            (RCAT, Widget *, Widget *, RCAT *, RmBool *, RmBool *, RmBool *));
extern Widget  PROTOTYPE( rmCreateLPrmEntryWindow,
            (Widget, RCAT, RCAT, RmBool, Widget *, Widget *, Widget *));

/*--------------------------------------------- popup/down CB */
extern void RmPROTOTYPE_CB( rmLPrmEditorPopupCB );
extern void RmPROTOTYPE_CB( rmLPrmEditorPopdownCB );

/*--------------------------------------------- widget create/set/get */
extern void PROTOTYPE( rmCreateModLModeEditor,   (Widget, Widget *));
extern void PROTOTYPE( rmCreateMinLExtEditor,    (Widget, RmWidSet *));
extern void PROTOTYPE( rmCreateExtLExtEditor,    (Widget, RmWidSet *));
extern void PROTOTYPE( rmCreateWgtLWeightEditor, (Widget, RmWidSet *));
extern void PROTOTYPE( rmCreateMixLGainEditor,   (Widget, RmWidSetM *));
extern void PROTOTYPE( rmCreateCreLGainEditor,   (Widget, RmWidSetC *));
extern void PROTOTYPE( rmCreateHstLGainEditor,   (Widget, RmWidSetH *));

extern void PROTOTYPE( rmSetLearnModeParameter,
                       (Widget *, int, unsigned long));
extern void PROTOTYPE( rmSetLearnExtParameter,
                       (RmWidSet *, RmWidSet *, RANA, RLEXT *));
extern void PROTOTYPE( rmSetLearnWeightParameter,
                       (RmWidSet *, Widget *, Widget *, RLWEIGHT *));
extern void PROTOTYPE( rmSetLearnGainParameter,
                       (RmWidSetH *, RmWidSetM *, RmWidSetC *, RANA, RLMFP *));
extern void PROTOTYPE( rmGetLearnModeParameter,
                       (Widget *, int, unsigned long *));
extern void PROTOTYPE( rmGetLearnExtParameter,
                       (RmWidSet *, RmWidSet *, RANA, RLEXT *));
extern void PROTOTYPE( rmGetLearnWeightParameter,
                       (RmWidSet *, Widget *, Widget *, RLWEIGHT *));
extern void PROTOTYPE( rmGetLearnGainParameter,
                       (RmWidSetH *, RmWidSetM *, RmWidSetC *, RANA, RLMFP *));

extern Ferr PROTOTYPE( rmDrawLearnEditorNames,
                       (RmIdInf *, RCAT, Widget *, RCAT, Widget *));

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* not _MMI00SIM_H_ */
