/*******************************************************************************
 *      (C)Copyright       AdIn Reserch, Inc.                 1991-1993.       *
 *******************************************************************************
 *******************************************************************************
 *
 *  File name    : mmi00usr.h
 *
 *  Note         : Header file for B-RNA graphic mmi
 *                    - for MMI's Applicatin -
 *
 * $Revision: 2.21 $
 * $Author: fujimaki $
 * $Date: 1999/11/05 03:04:05 $
 * $Locker:  $
 *
 ******************************************************************************/
 
#if !defined(_MMI00USR_H_)
#   define _MMI00USR_H_

/*----- include --------------------------------------------------------------*/
#include    "rna00usr.h"
#include    <Xm/Xm.h>

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/*----- Set Japanese Code Type -----------------------------------------------*/
#if !defined(JP_SJIS) && !defined(JP_EUC) && !defined(JP_JIS)
#   define  JP_JIS      (1)
#endif

/*----- Check real vale Zero -------------------------------------------------*/
#define     RmNEAR_ZERO    (1.0e-5)

/*----- Table window type ----------------------------------------------------*/
typedef enum {
    RmEDITOR,               /* normal editor        */
    RmLEARN,                /* learn simulator      */
    RmINFER,                /* infer simulator      */
    RmSENSOR                /* output sensor set    */
} RmWindowType;

typedef enum {
    RmPATTERN_TBL,          /* display mode is pattern table */
    RmPATTERN_SET,          /* display mode is pattern set   */
    RmPATTERN_UNDEF_TYPE /* not used */
} RmPtDispType;

/*----- local Bool -----------------------------------------------------------*/
typedef enum {
    RmFALSE = 0,            /* false */
    RmTRUE,                 /* true  */
    RmNOT_BOOL  /* not used */
} RmBool;

/*----- Define Types ---------------------------------------------------------*/
typedef GENPTR  RmTblID;

typedef struct {
    int          iNpat;
    int          iNana;
    int          iNdig;
    RmPtDispType mPatDisp;
    RmBool       mWeight;
} RmTblMode;

/*----- Define External Functions --------------------------------------------*/
extern Widget PROTOTYPE( RXtInitialize,         (char *, int, char **));
extern void   PROTOTYPE( RXtRealizeAndLoop,     (void));

extern Widget PROTOTYPE( RXMCreateDefaultMenu,  (Widget));
extern Ferr   PROTOTYPE( RXMInit,               (void));
extern Ferr   PROTOTYPE( RXMHalt,               (void));
extern Ferr   PROTOTYPE( RXMCreateTableWindow,  (RmWindowType, RID, RmTblID *));
extern Ferr   PROTOTYPE( RXMDeleteTableWindow,  (RmTblID));
extern Ferr   PROTOTYPE( RXMDrawTableWindow,    (RmTblID));
extern Ferr   PROTOTYPE( RXMSetTableWindowMode, (RmTblMode *));
extern Ferr   PROTOTYPE( RXMGetTableWindowMode, (RmTblMode *));

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* not _MMI00USR_H_ */
